SET SERVEROUTPUT ON;
spool proves.log
set echo on

/*------------------------*
 *     PROVES ABM         *
 *----------------------- */
/
/

DECLARE
   RSP VARCHAR2(500);
BEGIN
   --ALTA CORRECTA D'UN NOU MODEL
   SP_ALTA_MODEL_COMPTADOR('Model trifsic', 'ACME','AC1', 'NO', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP); 
   
   --ALTA D'UN MODEL QUE JA EXISTEIX
   SP_ALTA_MODEL_COMPTADOR('Model monofsic', 'SIEMENS','SM1', 'SI', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   --ALTA AMB VALORS NULS
   SP_ALTA_MODEL_COMPTADOR('Model trifsic antic', null,'ST1', 'SI', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   --ALTA CORRECTA D'UN NOU MODEL AMB CAMP TELEMATIC ERRONI
   SP_ALTA_MODEL_COMPTADOR('Model trifsic', 'ACME','ACX', 'NU', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
   
   --MODIFICACIO QUE DUPLICA UN ALTRE MODEL
   SP_MODIFICACIO_MODEL_COMPTADOR(7, 'Model monofsic', 'SIEMENS','SM1', 'SI', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP); 
  
   --BAIXA CORRECTA D'UN MODEL DE COMPTADOR
   SP_BAIXA_MODEL_COMPTADOR(7, RSP );
   DBMS_OUTPUT.PUT_LINE(RSP); 
END;
/


--COMPTADOR
DECLARE
   RSP VARCHAR2(500);
BEGIN

   --ALTA D'UN NOU COMPTADOR AMB  CAMP MODEL NUL
   SP_ALTA_COMPTADOR(null, 'adrea99, 221', 'sant vicenc', 'barcelona', 'spain', 2001, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   --ALTA D'UN NOU COMPTADOR AMB  CAMP MODEL INEXISTENT
   SP_ALTA_COMPTADOR(999, 'adrea99, 221', 'sant vicenc', 'barcelona', 'spain', 2001, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   --ALTA CORRECTA D'UN NOU COMPTADOR 
   SP_ALTA_COMPTADOR(1, 'adrea99, 221', 'sant vicenc', 'barcelona', 'spain', 2001, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   --MODIFICACI CORRECTA D'UN COMPTADOR
   SP_MODIFICACIO_COMPTADOR(14, 1, null, null, 'barcelona', null, 2001, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --MODIFICACI D'UN COMPTADOR AMB MODEL INEXISTENT
   SP_MODIFICACIO_COMPTADOR(14, 91, null, null, 'barcelona', null, 2001, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   --BAIXA D'UN COMPTADOR INEXISTENT
   SP_BAIXA_COMPTADOR(514, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
   --BAIXA CORRECTA D'UN COMPTADOR
   SP_BAIXA_COMPTADOR(1, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);


END;
/




--CLIENT
DECLARE
   RSP VARCHAR2(500);
BEGIN

   --ALTA D'UN NOU CLIENT AMB NIF NUL
   SP_ALTA_CLIENT(null, 'Antonio', 'vila', null, null, null, 'Bilbao', 'Spain', null, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);    
   
   --ALTA CORRECTA D'UN NOU CLIENT
   SP_ALTA_CLIENT('12345678A', 'Antonio', 'vila', null, null, null, 'Bilbao', 'Spain', null, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
   
   --ALTA D'UN CLIENT DUPLICAT
   SP_ALTA_CLIENT('12345678A', 'Antonio', 'vila', null, null, null, 'Bilbao', 'Spain', null, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
   
   --MODIFICACIO QUE DUPLICA EL NIF D'UN ALTRE CLIENT
   SP_MODIFICACIO_CLIENT(13, '22222222B', 'Antonio', 'vila', null, null, null, 'Bilbao', 'Spain', null, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
   
   --BAIXA CORRECTA D'UN CLIENT
   SP_BAIXA_CLIENT(2, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
END;
/



--CONTRACTE
DECLARE
   RSP VARCHAR2(500);
BEGIN


   --ALTA D'UN CONTRACTE AMB UN COMPTADOR JA ASSIGNAT A UN ALTRE CONTRACTE
   SP_ALTA_CONTRACTE(13, 4, 3700, SYSDATE, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
   
   --ALTA CORRECTA D'UN CONTRACTE 
   SP_ALTA_CONTRACTE(13, 14, 3, SYSDATE, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);   

   --BAIXA D'UN CONTRACTE 
   SP_BAIXA_CONTRACTE(5, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP); 
END;
/



--CENTRAL PRODUCCI
DECLARE
   RSP VARCHAR2(500);
BEGIN

   --MODIFICACIO CENTRAL AMB CAMPS NULS
   SP_MODIFICACIO_CENTRAL_PROD(2,'calle Madrid, 111', 'Madrid', 'Madrid', 'espaa', null, null, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
   
   --BAIXA D'UNA CENTRAL RELACIONADA AMB ALTRES ELEMENTS
   SP_BAIXA_CENTRAL_PROD(2, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
END;
/



--CENTRAL DISTRIBUCI
DECLARE
   RSP VARCHAR2(500);
BEGIN

   --MODIFICACIO CENTRAL AMB CAMPS NULS
   SP_MODIFICACIO_CENTRAL_DIST(2,'calle Madrid, 111', null, 'Madrid', 'espaa', 27000, null, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
   
   --BAIXA D'UNA CENTRAL RELACIONADA AMB ALTRES ELEMENTS
   SP_BAIXA_CENTRAL_DIST(2, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
END;
/


--LINIA COMUNICACI
DECLARE
   RSP VARCHAR2(500);
BEGIN

   --ALTA LINIA COMUNICACIO AMB CAMPS NULS
   SP_ALTA_LINIA_COM(null, null, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
   
   --ALTA LINIA COMUNICACIO 
   SP_ALTA_LINIA_COM(300, 5000, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);     
   
   --MODIFICACIO LINIA COMUNICACIO 
   SP_MODIFICACIO_LINIA_COM(12, 5000, 10000, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
   
   --BAIXA D'UNA LINIA RELACIONADA AMB ALTRES ELEMENTS
   SP_BAIXA_LINIA_COM(3, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);     
   
   --BAIXA CORRECTA D'UNA LINIA
   SP_BAIXA_LINIA_COM(12, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
END;
/




--DISTRIBUCI
DECLARE
   RSP VARCHAR2(500);
BEGIN

   --ALTA DISTRIBUCIO AMB CAMPS NULS
   SP_ALTA_DISTRIBUCIO(null, null,'SI', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  

   --ALTA DISTRIBUCIO AMB CAMPS ERRONIS
   SP_ALTA_DISTRIBUCIO(7, 14,'S', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  

   --ALTA CORRECTA D'UNA DISTRIBUCIO
   SP_ALTA_DISTRIBUCIO(7, 14,'SI', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
END;
/





--CONNEXI
DECLARE
   RSP VARCHAR2(500);
BEGIN

   --ALTA CONNEXI AMB CAMPS NULS
   SP_ALTA_CONNEXIO(null, null, 3, 'SI', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
   
   --ALTA CONNEXI AMB CAMPS INCORRECTES
   SP_ALTA_CONNEXIO(1, 2, 3, 'S', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);    
   
   --ALTA DUPLICADA D'UNA CONNEXI
   SP_ALTA_CONNEXIO(3, 7, 7, 'no', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);   
   
END;
/


--LECTURA
DECLARE
   RSP VARCHAR2(500);
BEGIN

   --ALTA D'UNA LECTURA D'UN COMPTADOR DONAT DE BAIXA
   SP_ALTA_LECTURA(5, '13/5/12', 2000, 'presencial', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
    
   --ALTA D'UNA LECTURA QUE NO S LA MS RECENT DONAT UN COMPTADOR
   SP_ALTA_LECTURA(13, '13/2/12', 2000, 'presencial', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP); 

   --BAIXA D'UNA LECTURA QUE NO S LA MS RECENT DONAT UN COMPTADOR
   SP_BAIXA_LECTURA(99, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP); 
   
   --MODIFICACI D'UNA LECTURA QUE NO S LA MS RECENT DONAT UN COMPTADOR
   SP_MODIFICACIO_LECTURA(99, '30/4/11', 22000, 'presencial', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);     

   --ALTA D'UNA LECTURA AMB VALOR INCORRECTE
   SP_ALTA_LECTURA(13, '13/6/12', 500, 'presencial', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
   
   --MODIFICACI D'UNA LECTURA AMB VALOR INCORRECTE
   SP_MODIFICACIO_LECTURA(279, '30/5/12', 500, 'presencial', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);  
    
   --ALTA D'UNA LECTURA SI NO EXISTEIX UN ALTRE AL MES ANTERIOR
   SP_ALTA_LECTURA(13, '13/8/12', 2000, 'presencial', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP); 
    
   --MODIFICACIO D'UNA LECTURA SI NO EXISTEIX UN ALTRE AL MES ANTERIOR
   SP_MODIFICACIO_LECTURA(279, '13/8/12', 2000, 'presencial', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);    
   
   
   --MODIFICACI D'UNA LECTURA AMB DATA INCORRECTA
   SP_MODIFICACIO_LECTURA(279, '30/4/11', 22000, 'presencial', RSP);
   DBMS_OUTPUT.PUT_LINE(RSP); 
   
END;
/





--DESFEM ALGUNS DELS CANVIS REALITZATS PER TAL DE NO AFECTAR A LES PROVES DE CONSULTES
-- I ESTADSTIQUES
DECLARE
   RSP VARCHAR2(500);
BEGIN

   --BAIXA CORRECTA D'UNA DISTRIBUCI
   SP_BAIXA_DISTRIBUCIO(20, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);

   --BAIXA CORRECTA D'UN COMPTADOR
   SP_BAIXA_COMPTADOR(14, RSP);
   DBMS_OUTPUT.PUT_LINE(RSP);
   
END;
/






-------------------
--TAULA CONTRACTE--
-------------------
/
SELECT * FROM CONTRACTE;
/



-------------------
--TAULA COMPTADOR--
-------------------
/
SELECT * FROM COMPTADOR ORDER BY 1;
/



------------------
--TAULA LECTURA--
-------------------
/
SELECT * FROM LECTURA WHERE comptador IN (1,2,5) ORDER BY 1;
/







/*------------------------*
 *  PROVES DE CONSULTES   *
 *----------------------- */


--	R6.a: donada una ciutat i una data com a parmetres, el llistat de tots els comptadors on 
--  el consum mensual de la data indicada ha superat el 80% del consum mitj de tots els 
--  comptadors de la ciutat en aquell mateix perode de temps: 
-----------------------------------------------------------------------------------------------
SELECT * FROM TABLE(FU_COMPT_MES_80_CONSUM('Madrid', '31/8/11'));
/

--	R6.b: Llistat de les 10 centraletes de distribuci que distribueixen ms energia.
-----------------------------------------------------------------------------------------------
SELECT * FROM TABLE(FU_TOP10_CENT_DIST());
/

--	R6.c: llistat de les 10 lnies de comunicaci ms carregades en relaci a la seva prpia 
--  capacitat mxima.
-----------------------------------------------------------------------------------------------
SELECT * FROM TABLE(FU_TOP10_LINIES());
/

--	R6.d: llistat dels clients que disposen de comptadors amb servei en alta disponibilitat.
-----------------------------------------------------------------------------------------------
SELECT * FROM TABLE(FU_CLIENTS_DISP());
/

--	R6.e: donada una central de producci i un interval de temps, el consum produt pels 
--  comptadors que depenen daquesta central i lenergia produda per la central en aquest 
--  perode de temps.
-----------------------------------------------------------------------------------------------
SELECT * FROM TABLE(FU_CONSUM_TEMP_CENTRAL(2,6,11,7,11));
/

--	R6.f: percentatge de lectures de comptadors efectuades de forma presencial i de forma 
--  telemtica en un perode de temps 
-----------------------------------------------------------------------------------------------
SELECT * FROM TABLE(FU_PERCENT_TIPUS_LEC(6,11,4,12));


--	R6.g: llistat de comptadors que tinguin un determinat nombre danys dantiguitat. 
-----------------------------------------------------------------------------------------------
SELECT * FROM TABLE(FU_COMPTADORS_ANTICS(2));
/





/*-------------------------------*
 *  PROVES DEL MDUL ESTADSTIC  *
 *------------------------------ */


--  R7.1: donada una central de producci, el consum dels comptadors que depenen de la central. 
-----------------------------------------------------------------------------------------------
SELECT * FROM EST1_CPROD_CONSUM WHERE central_produccio = 1;
/
DECLARE
   RSP VARCHAR2(500);
BEGIN
SP_BAIXA_COMPTADOR(7, RSP);
END;
/
SELECT * FROM EST1_CPROD_CONSUM WHERE central_produccio = 1;
/

--	R7.2: donada una lnia de comunicaci i un any concret, el valor mitj de lenergia 
--  consumida, tenint en compte que aquest consum depn dels comptadors que salimenten 
--  mitjanant aquesta lnia.
-----------------------------------------------------------------------------------------------
SELECT * FROM EST2_MITJA_CONSUM_LINIA WHERE anyo = 2012 AND linia = 9;
/
DECLARE
   RSP VARCHAR2(500);
BEGIN
SP_ALTA_LECTURA(4, '5/6/12', 1600, 'presencial', RSP);
END;
/
SELECT * FROM EST2_MITJA_CONSUM_LINIA WHERE anyo = 2012 AND linia = 9;
/

--	R7.3: lnia que ha estat ms carregada a nivell denergia consumida. 
-----------------------------------------------------------------------------------------------
SELECT * FROM EST3_LINIA_MES_CARREGA;

DECLARE
   RSP VARCHAR2(500);
BEGIN
SP_ALTA_LECTURA(13, '5/6/12', 2600, 'presencial', RSP);
END;
/
SELECT * FROM EST3_LINIA_MES_CARREGA;


--	R7.4: donat un any concret: percentatge de lnies que superen el 50% denergia consumida. 
-----------------------------------------------------------------------------------------------
SELECT * FROM EST4_LINIES_MES_50 WHERE anyo = 2012;
/
DECLARE
   RSP VARCHAR2(500);
BEGIN
SP_ALTA_LECTURA(3, '5/6/12', 1900, 'presencial', RSP);
END;
/
SELECT * FROM EST4_LINIES_MES_50 WHERE anyo = 2012;
/

--	R7.5: donat un any concret: el nombre de centrals de producci que generen menys del 30% 
--  de producci respecte de la seva capacitat mxima. 
-----------------------------------------------------------------------------------------------
SELECT * FROM EST5_CPROD_MENYS_30 WHERE anyo = 2012;
/
DECLARE
   RSP VARCHAR2(500);
BEGIN
SP_MODIFICACIO_PRODUCCIO_MENS(87, '31/5/12', 11200, RSP);
END;
/
SELECT * FROM EST5_CPROD_MENYS_30 WHERE anyo = 2012;
/

--	R7.6: top-10 de comptadors que histricament han tingut ms consum. 
-----------------------------------------------------------------------------------------------
SELECT * FROM EST6_COMPT_MES_CONSUM;
/
DECLARE
   RSP VARCHAR2(500);
BEGIN
SP_MODIFICACIO_LECTURA(282, '5/6/12', 2650, 'presencial', RSP);
END;
/
SELECT * FROM EST6_COMPT_MES_CONSUM;
/

--	R7.7: Consum mig de tots dels clients. 
-----------------------------------------------------------------------------------------------
SELECT * FROM EST7_MITJA_CONSUM_CLIENTS;
/
DECLARE
   RSP VARCHAR2(500);
BEGIN
SP_BAIXA_COMPTADOR(3, RSP);
END;
/
SELECT * FROM EST7_MITJA_CONSUM_CLIENTS;
/




-------------------
--TAULA LOGS--
-------------------
/
SELECT * FROM LOGS ORDER BY 1;
/
spool off
exit


